<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): Introduction</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li class="current"><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Introduction </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1><a class="anchor" id="overview_sec"></a>
Overview</h1>
<p>The TI Graph Library (TIGL) defines a set of standard API's for developing graph algorithms that supports multiple devices with multiple cores per device in the following configurations:</p>
<ol type="1">
<li>1 device with 1 ARM core</li>
<li>1 device with 4 ARM cores using OpenMP</li>
<li>Multiple devices with 1 ARM core using OpenMPI</li>
<li>Multiple Devices with 4 ARM cores using OpenMPI and OpenMP</li>
</ol>
<p>The TIGL is a software implementation of the Pregel model for graph processing proposed by Google <a class="el" href="citelist.html#CITEREF_Pregel">[1]</a>. Pregel is a message based system based on a bulk synchronization parallel (BSP) model <a class="el" href="citelist.html#CITEREF_BSP">[3]</a> where multiple devices perform local processing and exchange messages at a global timing barrier.</p>
<p>A graph algorithm is segmented into stages (called supersteps) that are executed sequentially and a global time barrier is used between successive stages to synchronize all workers (i.e., devices). Each worker performs computations for a subset of vertices in the graph and workers communicate by messages between the vertices.</p>
<p>At each superstep, each active vertex in each worker has a group of messages that are processed in the core compute function. The compute function produces a set of messages that are processed in the following superstep. The contents of the messages and the procedure for the compute function are dependent on the graph algorithm.</p>
<p>In addition to the core compute function, the interface defines a combine function. The combine function reduces the overall number of messages by combining messages going to a given destination vertex (usually using the sum or the max/min operators).</p>
<p>A general aggregate function collects global statistics for the algorithm and the graph that are shared by all vertices and can be used in the compute function. A graph algorithm terminates if the maximum number of supersteps is reached or if all vertices become inactive.</p>
<h1><a class="anchor" id="Use"></a>
Use</h1>
<p>The library uses C++ templates to allow the library user to define customized data structures for graph algorithms without modifying the core library. As such, most of the library is in the form of header files (.h and .hpp) that include both the definition and implementation of the template class.</p>
<p>Example applications are included for Page Rank, single source shortest paths (SSSP) and graph generation and test programs are included for the graph generation and mutation manager. To build the applications and test programs, set the environment variable TARGET_ROOTDIR to the root of the file system and use the included makefile with the following options:</p>
<p><code> make [TIGLDIR= &lt; tigL source directory &gt;][APPDIR= &lt; examples directory &gt;][HOST={X86,ARM}][OPENMP={YES(default),NO}][DEBUG_ENABLE={No(defualt),Yes}] [PROFILE_ENABLE={No(defualt),Yes}] </code></p>
<p><b>TIGLDIR</b> the root directory for the source code of <a class="el" href="classTIGL.html" title="Top level class for the TIGL engine  . ">TIGL</a></p>
<p><b>APPDIR</b> the app directory that contains the source code for the examples</p>
<p><b>HOST</b> describes the host processor to specify the compiler. The possible values are</p><ul>
<li>ARM compile for EVMK2H ARM host</li>
<li>X86 compile using GNU g++ for X86 machines</li>
</ul>
<p><b>OPENMP</b> = Yes/No indicates wheter OpenMP (i.e., multiple ARM cores) is enabled</p>
<p><b>DEBUG_ENABLE</b> = No/Yes : determines whether detailed debug information is generated while running</p>
<p><b>PROFILE_ENABLE</b> = No/Yes : determines whether detailed profiling information is generated while running</p>
<p>Another makefile builds all the test programs in test directory and it has similar syntax.</p>
<p>Executables generated by the makefile are created in the same directory as the example source code. An example command for running MPI programs is</p>
<p><code> &lt;mpidir&gt;/mpirun &ndash;mca orte_base_help_aggregate 0 &ndash;mca btl self,tcp -np &lt;NumDevices&gt; -host &lt;host1&gt;,&lt;host2&gt;,....,&lt;hostNumDevices&gt; &lt;programName&gt; &lt;program arguments&gt;=""&gt; </code></p>
<p>The Page Rank algorithm has 3 parameters, <code> ./appPageRank &lt;numVertices&gt; &lt;COMPARE_FLAG=yes/no&gt; &lt; graph filename &gt; </code></p>
<p>for example,</p>
<p><code> ./appPageRank 1024 yes ./adjlist1024x8.txt </code></p>
<p>reads the graph file ./adjlist1024x8.txt (which has an average of 8 edges/vertx), runs the Page Rank algorithm, and then compares it to the reference sequential implementation. The graph file may be generated by appGraphGenerate.</p>
<h1><a class="anchor" id="SW_Modules"></a>
Software Modules</h1>
<h2><a class="anchor" id="sw_overview_sec"></a>
Overview</h2>
<p>The main components of the TIGL library are summarized in the following figure. </p><div class="image">
<img src="modules.png" alt="modules.png"/>
</div>
 <p>The TIGL uses a vertex-centric message passing procedure to execute graph algorithms. Each worker is assigned a set of vertices, and it maintains a list of active vertices. At each superstep, active vertices process their input messages with a special function that is customized to the underlying graph algorithm. After processing, the vertices produce output messages that contain their updated information. In most cases, these messages target the neighboring vertices which may or may not exist on the same worker. Local messages (i.e., output messages to vertices on the same worker) are routed to the corresponding message buffer for the following superstep. External messages (i.e., output messages to vertices on other workers) are communicated to the corresponding device, and that device routes the received messages to the corresponding message buffer for the following superstep. Before the execution of the active vertices at the start of the superstep, the input messages may be combined to reduce the computation overhead.</p>
<p>The exchanged messages between vertices could be either computation messages (that is related to the algorithm computation) or mutation messages (that is related to the graph structure). Two types of message buffers are used to handle the two message types. Further, double buffering in a ping-pong fashion is used to simplify the interface.</p>
<p>Therefore, the main software modules for TIGL are:</p><ol type="1">
<li>Computation Manager: for handling the processing of vertices and routing input/output messages to the appropriate buffers.</li>
<li>Mutation Manager: for processing mutation messages.</li>
<li>Communication Manager: for handling external messages to other devices.</li>
<li>Data Manager: for providing a generic interface for vertex-centric graph representation.</li>
</ol>
<p>Communication between devices use standard MPI messaging. To increase the processing efficiency, multithreading using openMP is used on each device to parallelize the computation and communication tasks. The different tasks on the device exchange messages through intermediate buffers, with global status flags that monitor the progress of each task.</p>
<p>On each device, the pseudo-code for executing the engine is as follows (from <a class="el" href="classTIGL.html#a7ab28bce4a032f285d88b973ab982053" title="The highest level function for TIGL engine execution. ">TIGL::run</a>):</p>
<div class="fragment"><div class="line"><span class="comment">//comment: initializing all engine components</span></div>
<div class="line">dataManager-&gt;init();</div>
<div class="line">communicationManager-&gt;init();</div>
<div class="line"></div>
<div class="line"><span class="comment">//comment: running all tasks</span></div>
<div class="line">ComputeTask();</div>
<div class="line"><span class="keywordflow">if</span>(numDevices &gt; 1)</div>
<div class="line">{</div>
<div class="line">    TxTask();</div>
<div class="line">    RxTask();</div>
<div class="line">}</div>
</div><!-- fragment --><p>The computeTask can be summarized the following pseudo code (from <a class="el" href="classTIGL.html#a3b1b79f24fc14b6acbdeb1aaff64d36b" title="The core computation task. ">TIGL::computeTask</a>) </p><div class="fragment"><div class="line"><span class="comment">//comment: initializing all engine components</span></div>
<div class="line">initSuperStep();                        <span class="comment">// enable Tx/Rx</span></div>
<div class="line">computationManager-&gt;init();</div>
<div class="line">endSuperStep();                         <span class="comment">// flush and disable Tx/Rx</span></div>
<div class="line"></div>
<div class="line"><span class="keywordflow">while</span>(ALGORITHM_NOT_COMPLETED)</div>
<div class="line">{</div>
<div class="line">    <a class="code" href="group__misc__tools.html#ga12da4cca047aa79efda31868674fd69a">MPI_BARRIER</a>();                              <span class="comment">//comment: block synchronization point</span></div>
<div class="line">    initSuperStep();                            <span class="comment">// enable Tx/Rx</span></div>
<div class="line">    mutationManager-&gt;processMutations();</div>
<div class="line">    computationManager-&gt;superstep();            <span class="comment">//comment: executing a single superstep</span></div>
<div class="line">    endSuperStep();                             <span class="comment">// flush and disable Tx/Rx</span></div>
<div class="line">}</div>
</div><!-- fragment --><p>and the pseudo-code for the superstep execution (<a class="el" href="classTIGLComputationManager.html#a13e218d765c0f7d3ae0364ce9bcac100" title="Core superstep computation procedure. ">TIGLComputationManager::superstep</a>) is as follows </p><div class="fragment"><div class="line">    combineMessages();</div>
<div class="line">    initAggregateInfo();</div>
<div class="line">    clearMessageBuffers()</div>
<div class="line">  loop on active vertices</div>
<div class="line">  vertex = getVertex();</div>
<div class="line">  outMessages = execute(vertex, Messages(vertex))</div>
<div class="line">  updateAggregateInfo(vertex, outMessages);             <span class="comment">//comment: updating aggregate information</span></div>
<div class="line">  distributeOutMessages(currOutMessages, countSS);</div>
<div class="line">endloop</div>
</div><!-- fragment --><p>and the pseudo-code for distributeOutMessages is as follows </p><div class="fragment"><div class="line">loop on output messages</div>
<div class="line">      rcvr = getRcvr();</div>
<div class="line">      <span class="keywordflow">if</span> rcvr is local</div>
<div class="line">          add to the local message buffer of rcvr</div>
<div class="line">      <span class="keywordflow">else</span></div>
<div class="line">          add to the external message buffer</div>
<div class="line">  endloop</div>
</div><!-- fragment --><p>The Rx task proceeds as follows (from <a class="el" href="classTIGLCommunicationManager.html#a37761454cc4b64f11802bc6d55a12162" title="Core message receive routine. ">TIGLCommunicationManager::continuousRecvMessages</a>) </p><div class="fragment"><div class="line"><span class="keywordflow">while</span>(Rx is Disabled)</div>
<div class="line">    wait</div>
<div class="line">end</div>
<div class="line"></div>
<div class="line"><span class="keywordflow">while</span> there exist messages to receive</div>
<div class="line"></div>
<div class="line">    <span class="keywordflow">while</span> existMessage2Read</div>
<div class="line">        Start a Reading Thread</div>
<div class="line">    end</div>
<div class="line"></div>
<div class="line">    <span class="keywordflow">while</span> existMessage2Process</div>
<div class="line">        processSingleMessage(message)</div>
<div class="line">    end</div>
<div class="line">end <span class="comment">// of the target messags</span></div>
<div class="line">RxComplete = true;</div>
</div><!-- fragment --><p> Several non-blocking MPI read thread are activated in parallel to read the data/system/mutation messages from other devices.</p>
<p>Similarly, the Tx task proceeds as follows (from <a class="el" href="classTIGLCommunicationManager.html#a9076e5b7c635703b9207c107cfead352" title="High-level message TX routine. ">TIGLCommunicationManager::continuousSendMessages</a>)</p>
<div class="fragment"><div class="line"><span class="keywordflow">while</span>(Tx is Disabled)</div>
<div class="line">    wait</div>
<div class="line">end</div>
<div class="line"></div>
<div class="line"><span class="keywordflow">while</span> superstep is active</div>
<div class="line">    <span class="keywordflow">while</span> existMessage2Tx</div>
<div class="line">        Start a Tx Thread</div>
<div class="line">    end</div>
<div class="line">end <span class="comment">// of the target messags</span></div>
<div class="line">send to each device the total number of sent messages to that device</div>
<div class="line">TxComplete = <span class="keyword">true</span>;</div>
</div><!-- fragment --><h2><a class="anchor" id="data_container"></a>
Data Structures</h2>
<h3><a class="anchor" id="base_classes"></a>
Base Classes</h3>
<p>The two base classes for graph representation are the edge class and the vertex class. The edge class can have different interfaces depending on the graph topology. The basic edge class which is used with unweighted graphs is </p><div class="fragment"><div class="line"><span class="keyword">template</span> &lt;<span class="keyword">typename</span> <span class="keywordtype">id</span>Type&gt;</div>
<div class="line"><span class="keyword">class </span><a class="code" href="classTIGLContainersEdgeBase.html">TIGLContainersEdgeBase</a> {</div>
<div class="line">idType <a class="code" href="classTIGLContainersEdgeBase.html#a655d339702492c5f16db4c9cbd7bc2f8">node</a>;  <span class="comment">// the id of the target/src vertex</span></div>
<div class="line">}</div>
</div><!-- fragment --><p> For weighted graphs, another field is added to define the weight </p><div class="fragment"><div class="line"><span class="keyword">template</span>&lt;<span class="keyword">typename</span> <span class="keywordtype">id</span>Type, <span class="keyword">typename</span> dataType &gt;</div>
<div class="line"><span class="keyword">class </span><a class="code" href="classTIGLContainersEdgeW.html">TIGLContainersEdgeW</a>: <span class="keyword">public</span> <a class="code" href="classTIGLContainersEdgeBase.html">TIGLContainersEdgeBase</a>&lt;idType&gt; {</div>
<div class="line">dataType    <a class="code" href="classTIGLContainersEdgeW.html#acd4e16aaffa95106f6c26801948b50b9">edgeData</a>; <span class="comment">// edge weight information</span></div>
<div class="line">}</div>
</div><!-- fragment --><p>The base vertex class that contains minimal vertex information is <a class="el" href="classTIGLContainersVertexBase.html" title="Core vertex class. ">TIGLContainersVertexBase</a> which is defined as </p><div class="fragment"><div class="line"><span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> IdType &gt;</div>
<div class="line"><span class="keyword">class </span><a class="code" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>{</div>
<div class="line">IdType          <a class="code" href="classTIGLContainersVertexBase.html#a3f6edf01d8830e0b5b8ad74549eeb085">id</a>;             <span class="comment">// unique vertex ID</span></div>
<div class="line">DataType        <a class="code" href="classTIGLContainersVertexBase.html#a42054ed48c73a733e99f3ef80698e50b">vertexData</a>;     <span class="comment">// vertex data field</span></div>
<div class="line">AlgDataType     <a class="code" href="classTIGLContainersVertexBase.html#ac36b610433331bb36b1c05a1fa942418">algData</a>;        <span class="comment">// Algorithm-specific data</span></div>
<div class="line">OUT_EDGE_BUF    <a class="code" href="classTIGLContainersVertexBase.html#a8e0e018b11f1fbe310789c332efed1b9">outEdges</a>;       <span class="comment">// output edge buffer</span></div>
<div class="line">}</div>
</div><!-- fragment --><p>To enable messaging between vertices during processing, few extra fields are added to define the core vertex class <a class="el" href="classTIGLApiVertex.html" title="Core vertex class for the TIGL Engine (with only output edge buffer). ">TIGLApiVertex</a> that inherits the <a class="el" href="classTIGLContainersVertexBase.html" title="Core vertex class. ">TIGLContainersVertexBase</a> class </p><div class="fragment"><div class="line"><span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> InitType, <span class="keyword">typename</span> IdType, <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><span class="keyword">class </span><a class="code" href="classTIGLApiVertex.html">TIGLApiVertex</a>:<span class="keyword">public</span> <a class="code" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt;DataType, AlgDataType, EdgeType, IdType&gt;</div>
<div class="line">{</div>
<div class="line"><span class="keywordtype">bool</span>                    <a class="code" href="classTIGLApiVertex.html#a7f130ee572059d53540d2fe45012803a">flagActive</a>;         <span class="comment">// active flag</span></div>
<div class="line"></div>
<div class="line"><span class="keyword">public</span>:</div>
<div class="line"><span class="keyword">virtual</span> uint32 <a class="code" href="classTIGLApiVertex.html#a509bac1afaa2f2141616ae8fc06c0ddd">compute</a>(MESSAGE_BUF_TYPE * pIn, LOCAL_MESSAGE_BUF * pOut, uint32 numMessages);</div>
<div class="line"><span class="keyword">virtual</span> uint32 <a class="code" href="classTIGLContainersVertexBase.html#a53510bd15bbce08013705a779d3b191a">init</a>(INIT_TYPE * initParams, LOCAL_MESSAGE_BUF * pOut);</div>
<div class="line">}</div>
</div><!-- fragment --><p> The class has some more detalied attributes are described in the class documentation. Some of the class members are defined as as static because only a single copy of these attributes is needed for all objects. The class defines a virtual version of the two main API interface functions compute and init that need to be redefined by each graph algorithm.</p>
<h3><a class="anchor" id="containers"></a>
Container Classes</h3>
<p>In our implementation the graph is stored as an adjacency list, which is the list of vertices that make the graph along with their edges (the edges of each vertex are defined within the vertex object). The core container class is <a class="el" href="classTIGLContainersSubgraphBase.html" title="Core data container for a subgraph in each device. ">TIGLContainersSubgraphBase</a> whose data types are determined by the vertex type. </p><div class="fragment"><div class="line"><span class="keyword">template</span> &lt;<span class="keyword">typename</span> CVertex&gt;</div>
<div class="line"><span class="keyword">class </span><a class="code" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a></div>
<div class="line">{</div>
<div class="line">vector&lt;CVertex&gt; <a class="code" href="classTIGLContainersSubgraphBase.html#a56b37400e7d47e6a278084defcd26778">vertexList</a>;     <span class="comment">// physical storage of the subgraph</span></div>
<div class="line">POS_LIST_TYPE   <a class="code" href="classTIGLContainersSubgraphBase.html#a03aff1a6c6f8bac92420673d84542e2a">vertexPos</a>;      <span class="comment">// the position of each vertex</span></div>
<div class="line"><span class="keywordtype">bool</span>            <a class="code" href="classTIGLContainersSubgraphBase.html#a36346fc960bbe56f1ce1ab9d0f9f9fca">flagDirected</a>;   <span class="comment">// directed/undirected graph</span></div>
<div class="line">uint32          <a class="code" href="classTIGLContainersSubgraphBase.html#a4d2dc5c71e000a5a43abfb541b99ea97">posHashSize</a>;    <span class="comment">// the size of the position hash table</span></div>
<div class="line">}</div>
</div><!-- fragment --><p> The vertices are stored in vertexList buffer. To accelerate random-access of vertices, we use another buffer vertexPos that contains a hash table for vertex positions. The vertices are hashed by their id, and an ordered collision table is maintained to hold vertices with the same hash value.</p>
<p>The core container <a class="el" href="classTIGLContainersSubgraph.html" title="Graph container for each device in the TIGL. ">TIGLContainersSubgraph</a> inherits the <a class="el" href="classTIGLContainersSubgraphBase.html" title="Core data container for a subgraph in each device. ">TIGLContainersSubgraphBase</a> class and adds the necessary message buffers for messages-based processing. It is defined as follows </p><div class="fragment"><div class="line"><span class="keyword">template</span> &lt;<span class="keyword">typename</span> CVertex, <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><span class="keyword">class </span><a class="code" href="classTIGLContainersSubgraph.html">TIGLContainersSubgraph</a>:</div>
<div class="line"><span class="keyword">public</span> <a class="code" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>&lt;CVertex&gt;</div>
<div class="line">{</div>
<div class="line"><span class="comment">//  ping-pong  data message buffers</span></div>
<div class="line">vector&lt;MESSAGE_BUF_TYPE&gt; * <a class="code" href="classTIGLContainersSubgraph.html#a2e790b3ee9c89f14a2a583588d26c2cb">evenTimeMessages</a>;</div>
<div class="line">vector&lt;MESSAGE_BUF_TYPE&gt; * <a class="code" href="classTIGLContainersSubgraph.html#a950896b5e64c04c6ce1a017b5547e7f2">oddTimeMessages</a>;</div>
<div class="line"></div>
<div class="line">EXTERNAL_MESSAGE_BUF * <a class="code" href="classTIGLContainersSubgraph.html#a77992a2244609d65625766b2a159fe4e">externalOutMessages</a>;                 <span class="comment">//External Data messages buffer.</span></div>
<div class="line"></div>
<div class="line">vector&lt;TIGLCommunicationSysMessage&gt;  <a class="code" href="classTIGLContainersSubgraph.html#a2c08cd85fd08fbe3c06fbab83d78e833">outSysMessages</a>;        <span class="comment">// output system message buffer</span></div>
<div class="line"></div>
<div class="line"><span class="comment">// ping-pong Local system message buffer</span></div>
<div class="line">vector&lt;TIGLCommunicationSysMessage&gt;  <a class="code" href="classTIGLContainersSubgraph.html#a62f89f570e32c3ae471632171c44dd19">evenInSysMessages</a>;</div>
<div class="line">vector&lt;TIGLCommunicationSysMessage&gt;  <a class="code" href="classTIGLContainersSubgraph.html#a7327f746951694590bc27ec581771dfb">oddInSysMessages</a>;</div>
<div class="line"></div>
<div class="line"></div>
<div class="line">MUTATION_MBUF * <a class="code" href="classTIGLContainersSubgraph.html#a4c207d3ccc3b56aa2222bf792d939014">outMutationMessages</a>;                        <span class="comment">//  buffer of external mutation messages</span></div>
<div class="line">MUTATION_MBUF * <a class="code" href="classTIGLContainersSubgraph.html#a1590a714907035e3bb0ffbeda51aedab">inMutationMessages</a>;                         <span class="comment">//  Buffer for local mutation messages</span></div>
<div class="line"></div>
<div class="line">}</div>
</div><!-- fragment --><h3><a class="anchor" id="agg_container"></a>
Aggregate Information Container</h3>
<p>The aggregate information is an integral part of the Pregel engine, and it is used by graph algorithms for monitoring. The class container for aggregate information <a class="el" href="classTIGLContainersAggregate.html" title="Base class for aggregate information. ">TIGLContainersAggregate</a> is defined as </p><div class="fragment"><div class="line"><span class="keyword">template</span> &lt;<span class="keyword">typename</span> AlgData&gt;</div>
<div class="line"><span class="keyword">class </span><a class="code" href="classTIGLContainersAggregate.html">TIGLContainersAggregate</a></div>
<div class="line">{</div>
<div class="line">uint32 <a class="code" href="classTIGLContainersAggregate.html#a305621751cb671f32cfac297765b50bc">numVertices</a>;                             <span class="comment">// total number of vertices in the graph</span></div>
<div class="line">uint32 <a class="code" href="classTIGLContainersAggregate.html#adbea704396b2b82f8f9b260c86206e6e">numLocalVertices</a>;                        <span class="comment">// number of local vertices for this device</span></div>
<div class="line">uint32 <a class="code" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a>;                                 <span class="comment">// superstep counter</span></div>
<div class="line">uint32 <a class="code" href="classTIGLContainersAggregate.html#acc02e42cdc6d4cf91525e563535c6ac2">numTotalMessages</a>[AGGREGATE_HISTORY];     <span class="comment">// total number of output messages over a superstep history</span></div>
<div class="line">uint32 <a class="code" href="classTIGLContainersAggregate.html#adbc8349ec3065a2dfccebce5527bec82">numExternalMessages</a>[AGGREGATE_HISTORY];  <span class="comment">// total number of external output messages over a superstep history</span></div>
<div class="line">uint32 <a class="code" href="classTIGLContainersAggregate.html#a36c75840693e07da4d59fe8269720fa9">numLocalActiveNodes</a>[AGGREGATE_HISTORY];  <span class="comment">// number of local active nodes over a superstep history</span></div>
<div class="line">uint32 <a class="code" href="classTIGLContainersAggregate.html#a38a14d8e84fbe0103c1c043d4485d958">numTotalActiveNodes</a>[AGGREGATE_HISTORY];  <span class="comment">// total number of active nodes over a superstep history</span></div>
<div class="line">AlgData <a class="code" href="classTIGLContainersAggregate.html#ada6c83411d9eb54ddcba58b7db52c7ca">maxActiveAlgData</a>[AGGREGATE_HISTORY];    <span class="comment">// maximum value of algorithm data of all active vertices over a superstep history</span></div>
<div class="line">AlgData <a class="code" href="classTIGLContainersAggregate.html#adee5333a31d8f0199b059006b0b0a2c3">minActiveAlgData</a>[AGGREGATE_HISTORY];    <span class="comment">// minimum value of algorithm data of all active vertices over a superstep history</span></div>
<div class="line">AlgData <a class="code" href="classTIGLContainersAggregate.html#a6e2cc4436a685cf860d668266212f42d">sumActiveAlgData</a>[AGGREGATE_HISTORY];    <span class="comment">// the sum of the values of algorithm data of all active vertices over a superstep history</span></div>
<div class="line">}</div>
</div><!-- fragment --><p> The aggregate information includes basic statistics of the engine, including for example the number of active nodes and the number of output messages. It also contains some algorithm-specific information, e.g., the maximum and minimum value of the AlgData field of active vertices. The statistics are stored for a window of supersteps whose width is defined by AGGREGATE_HISTORY (which is set to 2 in the current release).</p>
<h2><a class="anchor" id="compute_module"></a>
Computation Manager</h2>
<p>The computation manager handles the vertex processing at each superstep. It executes the compute procedure for each active vertex, routes the output messages to the message buffers, combines local and external messages, and updates the aggregate information. It also has the initialization procedure that calls the init procedure of all local vertices. The main attributes of the compute manager class <a class="el" href="classTIGLComputationManager.html" title="Core Computation class for the TIGL. ">TIGLComputationManager</a> are : </p><div class="fragment"><div class="line"><span class="keyword">template</span> &lt;<span class="keyword">typename</span> SUBGRAPH_CLASS, <span class="keyword">typename</span> COMBINER_TYPE, <span class="keyword">typename</span> INIT_TYPE&gt;</div>
<div class="line"><span class="keyword">class </span><a class="code" href="classTIGLComputationManager.html">TIGLComputationManager</a></div>
<div class="line">{</div>
<div class="line">vector&lt;uint32&gt; <a class="code" href="classTIGLComputationManager.html#a636f467a499bd29d9151e3dd012c8194">activeList</a>;                              <span class="comment">// list of active vertices</span></div>
<div class="line">uint32 <a class="code" href="classTIGLComputationManager.html#a3acf15a44b963c38fac7fe053499fd81">numLocalActive</a>;                                  <span class="comment">// number of local active vertices</span></div>
<div class="line"><a class="code" href="classTIGLContainersAggregate.html">TIGLContainersAggregate&lt;ALG_DATA_TYPE&gt;</a> <a class="code" href="classTIGLComputationManager.html#a6a468af9d43aacf4c047b60d59549dfe">aggregateInfo</a>;   <span class="comment">// Aggregate Information object</span></div>
<div class="line">DATA_CONTAINER_CLASS * <a class="code" href="classTIGLComputationManager.html#a9a1d7cc592962f35c0b009f44b52beac">dataManager</a>;                     <span class="comment">// pointer to the data manager object</span></div>
<div class="line">COMBINER_TYPE * <a class="code" href="classTIGLComputationManager.html#a56931bcd432a1b5bfdb51e66c0c5aa86">combiner</a>;                               <span class="comment">// pointer to combiner object</span></div>
<div class="line">}</div>
</div><!-- fragment --><p>The activeList buffer is filled during the combine procedure where all nodes are checked for new messages. The core public functions of the <a class="el" href="classTIGLComputationManager.html" title="Core Computation class for the TIGL. ">TIGLComputationManager</a> are: <a class="el" href="classTIGLComputationManager.html#ad6620bad7b93a884ac61d8b9dbad72c9">init </a> and <a class="el" href="classTIGLComputationManager.html#a13e218d765c0f7d3ae0364ce9bcac100">superstep </a>. The <a class="el" href="classTIGLComputationManager.html#ad6620bad7b93a884ac61d8b9dbad72c9">init </a> procedure is called at the first superstep and has the form </p><div class="fragment"><div class="line">init</div>
<div class="line"><span class="keywordflow">for</span> index = 1: numLocalVertices</div>
<div class="line">    outMessages = verticesList(index).init()</div>
<div class="line">    distributeOutMessages(outMessages)</div>
<div class="line">    updateAggregateInformation(outMessages)</div>
<div class="line">end local vertices loop</div>
</div><!-- fragment --><p>The <a class="el" href="classTIGLComputationManager.html#a13e218d765c0f7d3ae0364ce9bcac100">superstep </a> procedure is similar but it processes only the active nodes, and runs the execute procedure of each active vertex rather than the init procedure. Further, at the beginning a combine function is called to combine all local and external messages, that were not available at the previous superstep, are combined. The <a class="el" href="classTIGLComputationManager.html#a13e218d765c0f7d3ae0364ce9bcac100">superstep </a> core function proceeds as follows</p>
<p><a class="el" href="classTIGLComputationManager.html#a13e218d765c0f7d3ae0364ce9bcac100">superstep </a> </p><div class="fragment"><div class="line">CombineMessages()</div>
<div class="line">processSystemMessages()</div>
<div class="line"></div>
<div class="line">while activeList is not empty</div>
<div class="line">    index = pop(activeList)</div>
<div class="line">    outMessages = verticesList(index).execute       <span class="comment">// comment: each vertex contains a pointer to its input message buffer</span></div>
<div class="line">    distributeOutMessages(outMessages)</div>
<div class="line">    updateAggregateInformation(outMessages)</div>
<div class="line">end active vertices loop</div>
<div class="line"></div>
<div class="line">if the activeList is empty</div>
<div class="line">    return ALGORITHM_COMPLETED</div>
<div class="line">endif</div>
</div><!-- fragment --><p>The function <a class="el" href="classTIGLComputationManager.html#a24ea788379f2e180e2f409ca2c41393e">distributeOutMessages</a> distributes external/local messages after vertex execution. In the current implementation, this function alone consumes approximately 50% of the overall execution time. A high level description is as follows</p>
<p><a class="el" href="classTIGLComputationManager.html#a24ea788379f2e180e2f409ca2c41393e">distributeOutMessages</a>(messagesBuffer) </p><div class="fragment"><div class="line"><span class="keywordflow">while</span> messagesBuffer is not empty</div>
<div class="line">    message = pop(messagesBuffer)</div>
<div class="line">    rcvrVertex = message.getRecvr()</div>
<div class="line">    if rcvrVertex is a local vertex</div>
<div class="line">        push message to rcvrVertex messageBuffer of the next superstep</div>
<div class="line">    else                    <span class="comment">// rcvrVertex is in another device</span></div>
<div class="line">        push to externalMessagesBuffer</div>
<div class="line">    endif</div>
<div class="line">end while</div>
</div><!-- fragment --><p>The last core function is <a class="el" href="classTIGLComputationManager.html#aca32d884b684440682dfcc9544f23da7">combineMessages</a> which combines input messages (both local and external) to each vertex prior to vertex execution.</p>
<p><a class="el" href="classTIGLComputationManager.html#aca32d884b684440682dfcc9544f23da7">combineMessages</a>(messagesBuffer) </p><div class="fragment"><div class="line"><span class="keywordflow">for</span> index = 1: numLocalVertices</div>
<div class="line">    <span class="keywordflow">if</span> verticesList(index).hasMessages</div>
<div class="line">        verticesList(index).combineMessages  <span class="comment">// including combining from buffers of all threads</span></div>
<div class="line">        push index to activeList</div>
<div class="line">    <span class="keywordflow">else</span></div>
<div class="line">        <span class="keywordflow">if</span> verticesList(index).isActive</div>
<div class="line">            push index to activeList</div>
<div class="line">        endif</div>
<div class="line">    endif</div>
<div class="line">endfor</div>
</div><!-- fragment --><h2><a class="anchor" id="comm_module"></a>
Communication Manager</h2>
<p>The communication manager handles communication between devices. It is used only if more than one device is used. The core communication class is </p><div class="fragment"><div class="line"><span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_CONTAINER_TYPE&gt;</div>
<div class="line"><span class="keyword">class </span><a class="code" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a></div>
<div class="line">{</div>
<div class="line">DATA_CONTAINER_TYPE * <a class="code" href="classTIGLCommunicationManager.html#aad508b38f058c54ba1ac037995be39b3">dataPtr</a>;  <span class="comment">// pointer to the graph container that has all the message buffers</span></div>
<div class="line">uint32 <a class="code" href="classTIGLCommunicationManager.html#a4ae7ac30bbb2d7938b2bed7b4a4f21db">numDevices</a>;              <span class="comment">// total number of devices</span></div>
<div class="line">uint64 <a class="code" href="classTIGLCommunicationManager.html#ad4af56522c0cbc793788b38985e086c8">totalNumVertices</a>;        <span class="comment">// total number of vertices in the whole graph</span></div>
<div class="line">uint32 <a class="code" href="classTIGLCommunicationManager.html#a7f26b4bdfbe6ad5b50ecde994314dafc">rank</a>;                    <span class="comment">// rank of current device</span></div>
<div class="line">}</div>
</div><!-- fragment --><p>The vertex processing is fully distributed and we do not have a controller device that oversees all the messaging. Therefore, some system messages are broadcasted to all devices to share the algorithm status. There are two buffers in the data manager for the input and output system messages, and we have a separate buffer for the output data messages. We use the non-blocking MPI calls MPI_Isend() and MPI_Irecv() to send/receive messages in TX and RX tasks respectively</p>
<p>The communication manager is also used to help the <a class="el" href="classTIGLMutationManager.html">Mutation Manager</a> in distributed construction of the graph (see <a class="el" href="classTIGL.html#a70e3fc3f8dde6ef1c8bdbad2fba1f0bd" title="Newtwork reading subgraph from file. ">TIGL::networkReadGraph</a>), where a single device reads the whole graph from a file and sends mutation messages to all other devices.</p>
<h2><a class="anchor" id="mutation_module"></a>
Mutation Manager</h2>
<p>The mutation manager process all mutation messages during graph construction or during algorithm execution. The class definition is <a class="el" href="classTIGLMutationManager.html" title="Mutation manager class. ">TIGLMutationManager</a>, which contains methods for all graph mutations.</p>
<h2><a class="anchor" id="engine_module"></a>
Library Interface</h2>
<p>The high-level interface class to the TIGL is the <a class="el" href="classTIGL.html">TIGL </a> class which performs all necessary allocations. The main attributes of the class are</p>
<div class="fragment"><div class="line"><span class="keyword">template</span> &lt;<span class="keyword">typename</span> ALG_VERTEX_TYPE, <span class="keyword">typename</span> ALG_COMBINER&gt;</div>
<div class="line"><span class="keyword">class </span><a class="code" href="classTIGL.html">TIGL</a></div>
<div class="line">{</div>
<div class="line">uint32 <a class="code" href="classTIGL.html#a1928633793d2b130d62b93a6999fb415">rank</a>;                            <span class="comment">// rank of the device</span></div>
<div class="line">DATA_CONTAINER_TYPE * <a class="code" href="classTIGL.html#a59fcdfd2bacee67418e182f347f898f7">dataManager</a>;      <span class="comment">// The data manager object</span></div>
<div class="line">COMMUNICATOR_TYPE* <a class="code" href="classTIGL.html#a350034bc25d3ef9fc5427c01eb51b280">communicationManager</a>;<span class="comment">// The communication manager</span></div>
<div class="line">COMPUTATION_TYPE * <a class="code" href="classTIGL.html#a38c56842f9838f3c58f7fd15fc6c6bf7">computationManager</a>;  <span class="comment">// the computation manager object</span></div>
<div class="line">ALG_COMBINER * <a class="code" href="classTIGL.html#a5541f512541b62a53b718520ba942625">combiner</a>;                <span class="comment">// the user-defined combiner object</span></div>
<div class="line">MUTATION_TYPE * <a class="code" href="classTIGL.html#acd9412890896557621ab288764a83f44">mutationManager</a>;        <span class="comment">// the mutation manager</span></div>
<div class="line">uint32 <a class="code" href="classTIGL.html#affa2deafa252a76aabf16e1b52c5992d">numDevices</a>;                      <span class="comment">//total number of devices (1 if MPI is not used)</span></div>
<div class="line">uint32 <a class="code" href="classTIGL.html#aff8f26ab7c900ed74baa523afc72f369">numLocalVertices</a>;                <span class="comment">// number of local vertices</span></div>
<div class="line"><span class="keywordtype">bool</span> <a class="code" href="classTIGL.html#abb3c1874d24580f08b4794d7b3e1fd8b">flagDirected</a>;                      <span class="comment">// directed/undirected graph</span></div>
<div class="line">uint32 <a class="code" href="classTIGL.html#aef38bee1457371fb710a3146bff6fc6f">countSS</a>;                         <span class="comment">// superstep counter</span></div>
<div class="line">}</div>
</div><!-- fragment --><p>A graph algorithm in the framework is fully parameterized by the definition of the vertex class and the combiner class. These are the two template parameters of the <a class="el" href="classTIGL.html" title="Top level class for the TIGL engine  . ">TIGL</a> class. The core procedure in this class is <a class="el" href="classTIGL.html#a7ab28bce4a032f285d88b973ab982053">run</a> which, as the name implies, runs the engine to execute the graph algorithm as defined by the vertex class. The interface class has also few simple I/O and profiling functions to load a graph from a file and evaluate the algorithm output (as well as the speed) as documented in the detailed library documentation</p>
<h1><a class="anchor" id="alg"></a>
Example Algorithms</h1>
<h2><a class="anchor" id="pageR"></a>
Page Rank</h2>
<p>Page Rank is a standard graph algorithm that assigns ranks to vertices in a graph <a class="el" href="citelist.html#CITEREF_PageRank">[2]</a>. The page rank of a vertex is proportional to the importance of the vertex in the graph which is measured by the number of input edges weighted by the importance of the source vertex. The page rank (PR) of a vertex u is expressed as</p>
<p><a class="anchor" id="Formula"></a> <img class="formulaInl" alt="$ PR(u) = \sum_{v \in N(u)} PR(v)/L(v) $" src="form_1.png"/></p>
<p>where L(v) is the number of edges connected to vertex v and N(u) is the set of neighbor vertices to vertex u. The output page rank is a vector whose length is the number of vertices in the graph. It was shown in <a class="el" href="citelist.html#CITEREF_PageRank">[2]</a> that this vector is related to the overal graph structure. It is related to the eigenvector of the largest eigenvalue of the modified adjacency matrix representation of the graph <a class="el" href="citelist.html#CITEREF_PageRank">[2]</a>.</p>
<p>The algorithm is computed recursively with the core compute function as</p>
<p><a class="anchor" id="recursive"></a> <img class="formulaInl" alt="$ PR(u, t+1) = 0.15/numVertices + 0.85*\sum_{v \in N(u)} PR(v, t)/L(v) $" src="form_3.png"/></p>
<p>where PR(v, t) is the rank of vertex v at superstep t.</p>
<p>For this algorithm, the combine function sums the value of all messages from neighboring vertices. The compute function has the form PR(v, t+1) = 0.15/num_vertices + 0.85*sum_messages and the new page rank is broadcasted to all neighbors as a message with the value PR(v, t+1)/L(v). The customized vertex definition for the page rank algorithm is <a class="el" href="classPageRankVertex.html" title="Customized class for the Page Rank algorithm. ">PageRankVertex</a>. The algorithm is terminated after a predetermined number of supersteps is reached (e.g., 30).</p>
<h2><a class="anchor" id="SSSP"></a>
Single Source Shortest Path</h2>
<p>The single source shortest path problem aims at finding the shortest path between each vertex in the graph and a source vertex. The provided example uses a variation of the standard Dijkstra algorithm with the messages that are exchanged between vertices containing the current distance between each vertex and the source. The algorithm proceeds as follows</p>
<div class="fragment"><div class="line"><span class="keywordflow">for</span> all active vertices</div>
<div class="line">   <span class="keywordflow">for</span> all received messages</div>
<div class="line">         newDistance = min(oldDistance, messeageValue);</div>
<div class="line"></div>
<div class="line">      broadcast newDistance to all neighbors;</div>
<div class="line">      <span class="keywordflow">if</span> the newDistance is less than globalMinDistance</div>
<div class="line">         deactivate the vertex;</div>
</div><!-- fragment --><p>The combine function in this case is the minimum operator. The customized vertex definition for the single source shortest path algorithm is VertexP_SSSP. The algorithm is terminated if there is no active nodes or if there is no new messages.</p>
<h1><a class="anchor" id="build_sec"></a>
Developing New Graph Algorithms</h1>
<p>In the following, a step by step example is shown for developing a graph algorithm using TIGL using Page Rank as described in an earlier section.</p>
<p>The first step in developing a new graph algorithm is defining the customized vertex class that inherits the core <a class="el" href="classTIGLApiVertex.html">TIGLApiVertex </a> class. For the Page Rank algorithm the <a class="el" href="classTIGLContainersVertexBase.html#ac36b610433331bb36b1c05a1fa942418">algData </a> attribute holds the rank of each vertex, which is defined as a double precision floating point number. The ID field of each vertex can be defined as uint32 or uint64 depending on the graph size. Each vertex also needs to know the total number of vertices in the graph for the Page Rank computation.</p>
<p>The messages that are exchanged between neighboring vertices contain the Page Rank estimate of each vertex at the current superstep. Therefore, the customized message class is defined as </p><div class="fragment"><div class="line"><span class="keyword">typedef</span> Message&lt;double, uint_fast32_t&gt; <a class="code" href="classTIGLApiMessage.html">DblMessage</a>;</div>
</div><!-- fragment --><p>For unweighted graphs, the edge object is a simple customization of the core <a class="el" href="classTIGLContainersEdgeBase.html" title="Core edge class. ">TIGLContainersEdgeBase</a> class.</p>
<p>In the customized <a class="el" href="classTIGLApiVertex.html" title="Core vertex class for the TIGL Engine (with only output edge buffer). ">TIGLApiVertex</a> class, it’s necessary to redefine the <a class="el" href="classTIGLApiVertex.html#a846155817024d5eb7c732a3989b639f1">init</a> and the <a class="el" href="classTIGLApiVertex.html#a509bac1afaa2f2141616ae8fc06c0ddd">compute </a> functions. For Page Rank, the initial value of the Page Rank of each vertex is set as 0.15/numVertices. The compute function implements the <a class="el" href="index.html#recursive">recursive</a> Page Rank formula. Therefore, the customized vertex class <a class="el" href="classPageRankVertex.html" title="Customized class for the Page Rank algorithm. ">PageRankVertex</a> can be defined as</p>
<div class="fragment"><div class="line"><span class="keyword">class </span><a class="code" href="classPageRankVertex.html">PageRankVertex</a>:</div>
<div class="line"><span class="keyword">public</span> <a class="code" href="classTIGLApiVertex.html">TIGLApiVertex</a>&lt;DataType, double, TIGLContainersEdgeBase&lt;uint_fast32_t&gt;, uint_fast32_t, uint_fast32_t, DblMessage&gt;</div>
<div class="line">{</div>
<div class="line"><span class="keyword">protected</span>:</div>
<div class="line"><span class="keyword">static</span> uint_fast32_t <a class="code" href="classPageRankVertex.html#a34843c26de6abc929d7583aac0a37512">numVertices</a>;   <span class="comment">// the total number of vertices in the graph</span></div>
<div class="line"><span class="keyword">public</span>:</div>
<div class="line">uint_fast32_t <a class="code" href="classPageRankVertex.html#a5efbbc3acedbe1f3a98651f231d7830a">compute</a>(inputMessageBuffer, outMessageBuffer)</div>
<div class="line">{</div>
<div class="line"></div>
<div class="line">Iterate over all input messages</div>
<div class="line">{</div>
<div class="line">    newRank += messageContent();</div>
<div class="line">}</div>
<div class="line"></div>
<div class="line"><a class="code" href="classTIGLContainersVertexBase.html#ac36b610433331bb36b1c05a1fa942418">algData</a> = newRank*0.85 + 0.15/<a class="code" href="classPageRankVertex.html#a34843c26de6abc929d7583aac0a37512">numVertices</a>;</div>
<div class="line"></div>
<div class="line"></div>
<div class="line"><span class="comment">// prepare output messages to all neighbors</span></div>
<div class="line">Iterate over all Neigbors</div>
<div class="line">    prepare a message to the neigbor that contains the updated <a class="code" href="classTIGLContainersVertexBase.html#ac36b610433331bb36b1c05a1fa942418">algData</a></div>
<div class="line">    push the message to outMessageBuffer</div>
<div class="line">endfor</div>
<div class="line"></div>
<div class="line"><span class="keywordflow">if</span> maximum number of supersteps is reached</div>
<div class="line">    <a class="code" href="classTIGLApiVertex.html#adbaa2555fe812c8660c9a5414e9bac75">vote_to_halt</a>();</div>
<div class="line"></div>
<div class="line"><span class="keywordflow">return</span> the number of output messages;</div>
<div class="line">}</div>
<div class="line"></div>
<div class="line">uint_fast32_t <a class="code" href="classTIGLContainersVertexBase.html#a53510bd15bbce08013705a779d3b191a">init</a>(outMessageBuffer)</div>
<div class="line">{</div>
<div class="line"><a class="code" href="classTIGLContainersVertexBase.html#ac36b610433331bb36b1c05a1fa942418">algData</a> = 0.15/(double)<a class="code" href="classPageRankVertex.html#a34843c26de6abc929d7583aac0a37512">numVertices</a>;</div>
<div class="line"></div>
<div class="line">Write <a class="code" href="classTIGLContainersVertexBase.html#ac36b610433331bb36b1c05a1fa942418">algData</a> to the outputMessageBuffer that contains messages to all neighbors</div>
<div class="line"><span class="keywordflow">return</span> the number of output messages;</div>
<div class="line">}</div>
<div class="line"></div>
<div class="line">};</div>
</div><!-- fragment --><p>The following step is to define the combiner class. In our case, the combine function simply sums the estimated page rank of all neighbors. Hence the customized combiner tiglCombinerPageR that inherits the core tiglCombiner class has the form:</p>
<div class="fragment"><div class="line"><span class="keyword">class </span>tiglCombinerPageR:  <span class="keyword">public</span> tiglCombiner&lt;DblMessage&gt;</div>
<div class="line">{</div>
<div class="line"><span class="keyword">inline</span> uint32_t combineMessages(inputMessagesBuffer, outputMessagesBuffer)</div>
<div class="line">{</div>
<div class="line"><span class="keywordflow">return</span> this-&gt;sumCombineMessages(inputMessagesBuffer, outputMessagesBuffer);</div>
<div class="line">}</div>
<div class="line">};</div>
</div><!-- fragment --><p>At this point, a new algorithm, that can use the TIGL engine, has already been defined. To run the algorithm from the user program, the user needs to instantiate a <a class="el" href="classTIGL.html" title="Top level class for the TIGL engine  . ">TIGL</a> object with the customized class definitions of this algorithm as its parameters, i.e., define </p><div class="fragment"><div class="line"><a class="code" href="classTIGL.html">TIGL &lt;PageRankVertex&lt;char&gt;</a>, tiglCombinerPageR&gt;</div>
<div class="line">tiglInterface(DIRECTED_FLAG, NumVertices, deviceRank, numDevices);</div>
</div><!-- fragment --><p>and to execute the page rank algorithm within the user program (after loading the corresponding graph), a single command is called </p><div class="fragment"><div class="line">tiglInterface.run(MAX_SUPERSTEPS, &amp;initParams);</div>
</div><!-- fragment --><p>where initParams are simply the total number of vertices in the graph.</p>
<p>The final step is to customize the makefile that defines the hardware configuration through the compiling flags as described in the earlier section. </p>
</div></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:59 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
